package com.javaxpert.books.osgi.xml.api;

import java.io.InputStream;
import java.io.OutputStream;

import aQute.bnd.annotation.component.Component;

/**
 * <p>
 * Cette interface  propose des services permettant de sérialiser/désérialiser
 * des objets Java vers/depuis du XML.
 * </p>
 * @author J.MOLIERE , jerome@javaxpert.com
 *
 */
@Component
public interface IXMLSerializer {
	/**
	 * <p>
	 * creation d'un flux XML à partir d'un objet Java
	 * </p>
	 * @param target, objet à sérialiser en XML
	 * @return flux de sortie
	 */
	public OutputStream marshall2XML(Object target);
	
	/**
	 * <p>
	 * retrouve un objet Java à partir d'un flux XML
	 * </p>
	 * @param input, flux XMl d'entrée
	 * @return objet Java stocké sous forme de XML
	 */
	public Object unmarshallFromXML(InputStream input);

}
