package com.javaxpert.tests.tesngosgi;

import java.util.HashMap;
import java.util.Map;

import org.apache.felix.framework.Felix;
import org.apache.felix.main.Main;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleException;
import org.testng.annotations.BeforeGroups;
import org.testng.annotations.Test;
@Test(groups={"initFramework"})
public class BaseTest {
  private BundleContext bc;
  public BundleContext getBc() {
	return bc;
}

@BeforeGroups(groups="initFramework")
  public void setupFelix() {
	  System.out.println("setupfelix!!!");
	  Map map = new HashMap();
	  map.put("felix.fileinstall.dir", "bundles/");
	  map.put("felix.fileinstall.poll", "1000");
	  map.put("felix.fileinstall.log.level","4");
	  Felix felix = new Felix(map);
	  System.out.println("felix is ready now...");
	  try {
		felix.start();
		bc = felix.getBundleContext();
		// ceci sous entend une install 'standard' d'eclipse et du bndtools!!!
		String cnf_dir=System.getProperty("cnf.dir");
		Bundle osgi_cmpdn = bc.installBundle("file://"+ cnf_dir+"/cnf/repo/osgi.cmpn/osgi.cmpn-4.2.1.jar");
		osgi_cmpdn.start();
		Thread.sleep(2000);
		System.out.println("retrieved bundlecontext.....Is it null?"+ (bc==null?"yes":"No"));
		System.out.println("felix is ready now");
	} catch (BundleException e) {
		e.printStackTrace();
	} catch (InterruptedException e) {
		e.printStackTrace();
	}
  }
  
  @Test//(dependsOnGroups="initFramework")
  public void doSomeTesting(){
	  System.out.println("do some testing here!!!");
  }
}
