package com.javaxpert.books.osgi.thirbundle.clients;

import org.osgi.framework.BundleContext;

import com.javaxpert.books.osgi.thirdbundle.api.IHello;

import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Deactivate;

/**
 * un client du service pour dire bonjour
 * utilisant la version la plus minimaliste d'OSGi celle sans
 * injection de dépendances par le conteneur...
 * @author romje
 *
 */
@Component
public class StandardOSGiClient {
	
	public StandardOSGiClient(){
		
	}
	@Activate
	public void activate(BundleContext bc){
		// on va chercher une implémentation n'importe laquelle...
		// du service IHello
		// code requiert un enregistrement explicite du service fait par le bundle d'implémentation
		IHello hello= (IHello)bc.getService(bc.getServiceReference(IHello.class.getName()));
		if(hello!=null){
			System.out.println("standard client a trouve le service et l'invoque...");
			hello.sayHello();
		}
	}
	
	@Deactivate
	public void deactivate(BundleContext bc){
		System.out.println("Au revoir ...");
	}

}
