package com.javaxpert.books.osgi.thirdbundle.impl;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;

import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Deactivate;

import com.javaxpert.books.osgi.thirdbundle.api.IHello;

@Component
public class HelloServiceImpl implements IHello {
	private ServiceRegistration registration;
	@Override
	public void sayHello() {
		System.out.println("Hello from someone !!!");

	}
	
	@Activate
	public void activate(BundleContext bc){
		System.out.println("Hello implementation bundle est charge...");
		// enregistrement explicite du service
		// on sauvegarde cette référence pour la supprimer en cas d'arrêt du bundle
		registration=bc.registerService(IHello.class.getName(), this, null);
	}
	
	@Deactivate
	public void deactivate(BundleContext bc){
		System.out.println("hello impl s'en va!!");
		// on désenregistre explicitement le service à l'arrêt du bundle
		registration.unregister();
	}

}
