package test.consumer;

import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Properties;

import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;
import org.osgi.framework.ServiceRegistration;
import org.osgi.service.cm.ConfigurationAdmin;
import org.osgi.service.cm.ConfigurationException;
import org.osgi.service.cm.ManagedService;

import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Deactivate;
import aQute.bnd.annotation.component.Reference;

@Component
public class ExampleConsumer implements ManagedService{

	private ServiceRegistration registration;
	
	@Activate
	public void activate(BundleContext bc){
		System.out.println("Activated config consumer");
		Properties props =new Properties();
		props.put(Constants.SERVICE_PID, "TEST.com.javaxpert.testconfig");
		props.put("tcp.port","3000");
		registration=bc.registerService(ManagedService.class.getName(), this, props);
	}
	
	@Deactivate
	public void deactivate(BundleContext bc){
		System.out.println("goodbye crual world");
		registration.unregister();
	}

	@Override
	public void updated(Dictionary properties) throws ConfigurationException {
		System.out.println("Callback invoqued, someone changed config props");
		Dictionary props = (properties!=null?props=properties:new Hashtable());
		props.put(Constants.SERVICE_PID, "TEST.com.javaxpert.testconfig");
		
	}
}
