package test.guiprovider;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.util.Dictionary;
import java.util.Hashtable;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import org.osgi.framework.BundleContext;
import org.osgi.service.cm.Configuration;
import org.osgi.service.cm.ConfigurationAdmin;
import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Deactivate;
import aQute.bnd.annotation.component.Reference;

/**
 * <p>
 * interface swing simpliste permettant la modification du port TCP enregistré
 * par le biais du ConfigAdmin OSGi
 * </p>
 * @author romje
 */
@Component
public class ConfigGui extends JFrame {

	private ConfigurationAdmin configAdmin;
	
	// activation du bundle
	@Activate
	public void activate(BundleContext ctx){
		System.out.println("actvation de l'IHM");
		showGui();
		System.out.println("GUI affichee");
	}
	
	@Deactivate
	public void deactivate(BundleContext ctx){
		System.out.println("fermeture du bundle d'IHM");
		dispose();
		configAdmin=null;
	}
	
	// injection de dependances
	@Reference
	public void setConfigAdmin(ConfigurationAdmin admin) {
		configAdmin = admin;
	}

	public void unsetConfigAdmin(ConfigurationAdmin admin) {
		configAdmin=null;
	}

	public ConfigGui() {
		super("GUI de configuration");
		System.out.println("constructeur de l'IHM");
		initComponents();
	}// constructor()

	private void initComponents() {
		System.out.println("init composants graphiques");
		JPanel panel = (JPanel) getContentPane();
		panel.setLayout(new BorderLayout());
		panel.add("North", new JLabel("Configuration du port TCP du serveur"));
		JPanel center_panel = new JPanel();
		center_panel.setLayout(new FlowLayout());
		final JTextField tf = new JTextField("Entrée le port:");
		center_panel.add(tf);
		JButton ok = new JButton("Change config");
		center_panel.add(ok);
		panel.add("Center",center_panel);
		ok.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				int port = -1;
				try {
					port = Integer.parseInt(tf.getText().trim());
				} catch (RuntimeException exc) {

				}
				if (port == -1) {
					// update GUI with error
				} else {
					Configuration cfg = null;
					try {
						cfg = configAdmin
								.getConfiguration("TEST.com.javaxpert.testconfig");
						cfg.setBundleLocation(null);
						Dictionary props = cfg.getProperties();
						if (props == null) {
							props = new Hashtable();
						}
						props.put("tcp.port", port);
						cfg.update(props);
					} catch (IOException e1) {
						e1.printStackTrace();
					}

				}
			}
		});
		
	}// initComponents()
	
	private void showGui(){
		System.out.println("affichage de la GUI");
		pack();
		setVisible(true);
		//setSize(200, 200);
		setTitle("GUI config");
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				System.out.println("fermeture de la GUI");
				dispose();
			}		
		});
	}//showGui()
}
