package test.provider;

import java.io.IOException;
import java.util.Dictionary;
import java.util.Properties;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.cm.Configuration;
import org.osgi.service.cm.ConfigurationAdmin;
import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Deactivate;
@Component
public class ConfigProvider {
	private ConfigurationAdmin configAdmin;
	
	private Properties getConfig(){
		Properties props = new Properties();
		props.put("tcp.port", "3000");
		props.put("service.pid","TEST.com.javaxpert.testconfig");
		return props;
	}
	
	@Activate
	public void activate(BundleContext bc){
		// obtention d'une reference avec l'API classique
		// pas d'injection de dépendances ici
		ServiceReference ref = bc.getServiceReference(ConfigurationAdmin.class.getName());
		configAdmin = (ConfigurationAdmin)bc.getService(ref);
		System.out.println("ConfigAdmin fetched");
		if(configAdmin!=null){
			// recherche de la configuration 
			Configuration cfg;
			try {
				cfg = configAdmin.getConfiguration("TEST.com.javaxpert.testconfig");
				Dictionary props = cfg.getProperties();
				System.out.println("got cfg for PID = "+ cfg.getPid());
				System.out.println("Properties for this PID are ? ="+ (props==null?"null":" not null"));
				cfg.update(getConfig());
				// BIG hack - cf doc
				cfg.setBundleLocation(null);
				System.out.println("MAJ de la configuration par le provider...");
			} catch (IOException e) {
				e.printStackTrace();
			}
			
		}
	}
	@Deactivate
	public void deactivate(BundleContext bc){
		System.out.println("goodbye from provider");
	}
}
