package com.javaxpert.books.osgi.businessbundle;

import org.osgi.framework.BundleContext;
import com.javaxpert.books.osgi.registry.api.IClassRegistry;
import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Reference;

/**
 * <p>
 * une classe transportant de l'info sur un sujet métier
 * elle est publiee dans la registry pour pouvoir etre manipulee
 * par une classe d'une autre bundle 
 * </p>
 * @author romje
 *
 */
@Component
public class MaClasseMetier {

	private String nom;
	private  String adresse;
	private IClassRegistry registry;
	public MaClasseMetier(String _nom,String _adresse){
		nom=_nom;
		adresse=_adresse;
	}
	
	public MaClasseMetier(){
		
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public void setAdresse(String adresse) {
		this.adresse = adresse;
	}

	public String getNom() {
		return nom;
	}

	public String getAdresse() {
		return adresse;
	}
	
	@Reference
	public void setRegistry(IClassRegistry _registry){
		registry=_registry;
	}
	
	public void unsetRegistry(IClassRegistry _registry){
		registry=null;
	}
	
	@Activate
	public void activate(BundleContext _bc){
		if(registry!=null)
			registry.registerClass("toto", this.getClass());
	}
	
	public void deactivate(BundleContext _bc){
		if(registry!=null)
			registry.unregisterClass("toto");
	}
}
