package com.javaxpert.books.osgi.businessbundle2;
import org.osgi.framework.BundleContext;
import aQute.bnd.annotation.component.Activate;
import aQute.bnd.annotation.component.Component;
import aQute.bnd.annotation.component.Deactivate;
import aQute.bnd.annotation.component.Reference;
import com.javaxpert.books.osgi.registry.api.IClassRegistry;
import com.javaxpert.books.osgi.technicalbundle.api.IClassPrinter;

/**
 * cette classe a besoin d'infos sur une classe publiee
 * par un autre bundle
 * elle a donc usage de la registry...
 * @author romje
 *
 */
@Component(immediate=true)
public class MaClasseVoulantInfo {
	private IClassRegistry registry;
	private IClassPrinter printer;
	
	@Reference
	public void setRegistry(IClassRegistry _registry){
		registry=_registry;
	}
	
	public void unsetRegistry(IClassRegistry _registry){
		registry=null;
	}	
	@Reference
	public void setPrinter(IClassPrinter _printer){
		printer=_printer;
	}
	
	public void unsetPrinter(IClassPrinter _printer){
		printer=null;
	}
	@Activate
	public void activate(BundleContext _bc){
		if(registry!=null && printer!=null){
			String result=printer.displayClass(registry.getRegisteredClass("toto"));
			System.out.println("resultat des infos:\n"+ result);
		}
	}
	@Deactivate
	public void deactivate(BundleContext _bc){
	}
}
