package com.javaxpert.books.osgi.registry.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import aQute.bnd.annotation.component.Component;

import com.javaxpert.books.osgi.registry.api.IClassRegistry;
@Component
public class DefaultRegistryImpl implements IClassRegistry {

	private Map<String, Class> classesCache=new HashMap<String, Class>();
	
	@Override
	public void registerClass(String _name, Class _clazz) {
		if(_name!=null && _clazz!=null && !_name.trim().equals("") && !classesCache.containsKey(_name))
			classesCache.put(_name, _clazz);
	}

	@Override
	public void unregisterClass(String _name) {
		if(_name!=null && !_name.trim().equals("") && classesCache.containsKey(_name))
			classesCache.remove(_name);
	}

	@Override
	public boolean isClassInCache(String _name) {
		return (_name!=null && !_name.trim().equals("") && classesCache.containsKey(_name));
	}

	@Override
	public List<String> listClasses() {
		return new ArrayList<String>(classesCache.keySet());
	}

	@Override
	public Class getRegisteredClass(String _name) {
		return (isClassInCache(_name)==false?null:classesCache.get(_name));
	}

	@Override
	public void emptyCache() {
		

	}

}
